"""
Django settings for openlink_api project.

Generated by 'django-admin startproject' using Django 4.1.4.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""
import environ
from pathlib import Path
from datetime import timedelta
from django.core.management.utils import get_random_secret_key
from rest_framework.settings import api_settings
from django.core.management.utils import get_random_secret_key

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

env = environ.Env(
    # set casting, default value
    DEBUG=(bool, False),
)

env_paths = [
    environ.Path(Path.joinpath(BASE_DIR, '.env')),
    environ.Path("/etc/openlink/openlink.env"),
]

if env.str('OPENLINK_ENV_PATH', default='') != '':
    env_paths.insert(0, environ.Path(env.str('OPENLINK_ENV_PATH')))

# Read all environment files
for e in env_paths:
    try:
        e.file("")
        env.read_env(e())
    except FileNotFoundError:
        pass

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = env("SECRET_KEY", default=get_random_secret_key())

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = env("DEBUG")

ALLOWED_HOSTS = env.list("ALLOWED_HOSTS", default=['localhost'])

# Application definition
INSTALLED_APPS = [
    "corsheaders",
    "knox",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "openlink_api.core.apps.ApiConfig",
    "rest_framework",
    "openlink_api",
]
default_connectors = [
    'openlink_api.connectors.openlink_galaxy',
    'openlink_api.connectors.openlink_sshfs',
    'openlink_api.connectors.openlink_omero',
    'openlink_api.connectors.openlink_labguru'
]

INSTALLED_CONNECTORS = env.list("INSTALLED_CONNECTORS", default=default_connectors)
INSTALLED_APPS.extend(INSTALLED_CONNECTORS)

AUTH_USER_MODEL = "core.OpenlinkUser"

MIDDLEWARE = [
    "corsheaders.middleware.CorsMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

ROOT_URLCONF = "openlink_api.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "openlink_api.wsgi.application"


# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

if env.str('DATABASE_URL', default=''):
    DATABASES = {
        'default': env.db(),
    }
else:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': BASE_DIR / "db.sqlite3",
        },
    }

# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/

STATIC_URL = "/static/"
STATIC_ROOT = ".static"

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

REST_FRAMEWORK = {
    "DEFAULT_AUTHENTICATION_CLASSES": ("knox.auth.TokenAuthentication",),
    "DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination",
    "PAGE_SIZE": 10,
}

REST_KNOX = {
    "SECURE_HASH_ALGORITHM": "cryptography.hazmat.primitives.hashes.SHA512",
    "AUTH_TOKEN_CHARACTER_LENGTH": 64,
    "TOKEN_TTL": timedelta(hours=8),
    "USER_SERIALIZER": "knox.serializers.UserSerializer",
    "TOKEN_LIMIT_PER_USER": None,
    "AUTO_REFRESH": True,
    "EXPIRY_DATETIME_FORMAT": api_settings.DATETIME_FORMAT,
}

CORS_ALLOW_ALL_ORIGINS = True

AUTHENTICATION_BACKENDS = [
    "django.contrib.auth.backends.ModelBackend"
]

OPENLINK_AUTH_BACKEND = env("OPENLINK_AUTH_BACKEND")  # LDAP or JWT
if OPENLINK_AUTH_BACKEND == "LDAP":
    import ldap
    from django_auth_ldap.config import LDAPSearch
    AUTHENTICATION_BACKENDS.insert(0, "django_auth_ldap.backend.LDAPBackend")
    AUTH_LDAP_SERVER_URI = env("AUTH_LDAP_SERVER_URI")
    ldap.set_option(ldap.OPT_X_TLS_REQUIRE_CERT, ldap.OPT_X_TLS_NEVER)
    AUTH_LDAP_BIND_DN = env("AUTH_LDAP_BIND_DN")
    AUTH_LDAP_BIND_PASSWORD = env("AUTH_LDAP_BIND_PASSWORD")
    AUTH_LDAP_USER_SEARCH = LDAPSearch(
        env("AUTH_LDAP_SEARCH"), ldap.SCOPE_SUBTREE, "(uid=%(user)s)"
    )
    AUTH_LDAP_USER_ATTR_MAP = env.json("AUTH_LDAP_USER_ATTR_MAP")

if OPENLINK_AUTH_BACKEND == "JWT":
    OPENLINK_JWT_AUTHORIZED_CLIENT = [client.split(':') for client in env.list('OPENLINK_JWT_AUTHORIZED_CLIENT')]
    OPENLINK_VAULT_AUTH_ROLE = env('OPENLINK_VAULT_AUTH_ROLE')

# Vault settings
OPENLINK_VAULT_URL = env("OPENLINK_VAULT_URL")
OPENLINK_VAULT_AUTH_PATH = env('OPENLINK_VAULT_AUTH_PATH')
